#ifndef CIRC8_CPP
#define CIRC8_CPP

#ifdef _WIN32
        #include <windows.h>
	#include <shlobj.h>
#endif
                
#include "circuit8.h"

Circuit8* Circuit8::Instance()
{
   static Circuit8 t;
   return &t;
}

Circuit8::Circuit8()
{
	screenidx = 0;
	upscrolls = 0;
//	cout << screenidx << endl;
	int ctr = screenidx;
	for (ctr = 0; ctr < 1026; ctr++) {
//		cout << screenidx << endl;
		for (int i = 0;i<65;i++) {
			for (int p = 0;p<49;p++) {
//				cout << ctr << i << p << endl;
				screen.screen[i][p].r[ctr] = 0;
				screen.screen[i][p].g[ctr] = 0;
				screen.screen[i][p].b[ctr] = 0;
			}
		}
	}
	screenidx = 32;
	screendirection = 1;
	framecoloffset = 0;
}

void Circuit8::moreRed(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge morered amount (nan?) : " << amount << endl;amount = .01f; } else if (amount < 0 || amount != amount) { cout << "negative morered amount (nan?): " << amount << endl;  amount = 0; }
	screen.screen[x][y].r[screenidx] += amount;
	if (screen.screen[x][y].r[screenidx] > 1.0f) screen.screen[x][y].r[screenidx] = 1.0f;
}

void Circuit8::lessRed(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessred amount (nan?) : " << amount << endl;amount = .01f; } else if (amount < 0 || amount != amount) { cout << "negative lessred amount (nan?): " << amount << endl;  amount = 0; }
	screen.screen[x][y].r[screenidx] -= amount;
	if (screen.screen[x][y].r[screenidx] < 0) screen.screen[x][y].r[screenidx] = 0;
}

void Circuit8::moreGreen(unsigned int x, unsigned int y, float amount)
{
	// flamount
	if (amount > 1.0f) { cout << "huge moregreen amount (nan?) : " << amount << endl;amount = .01f; } else if (amount < 0 || amount != amount) { cout << "negative moregreen amount (nan?): " << amount << endl;  amount = 0; }
	screen.screen[x][y].g[screenidx] += amount;
	if (screen.screen[x][y].g[screenidx] > 1.0f) screen.screen[x][y].g[screenidx] = 1.0f;
}

void Circuit8::lessGreen(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessgreen amount (nan?) : " << amount << endl;amount = .01f; } else if (amount < 0 || amount != amount) { cout << "negative lessgreen amount (nan?): " << amount << endl;  amount = 0; }
	screen.screen[x][y].g[screenidx] -= amount;
	if (screen.screen[x][y].g[screenidx] < 0) screen.screen[x][y].g[screenidx] = 0;
}

void Circuit8::moreBlue(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge moreblue amount (nan?) : " << amount << endl; amount = .01f;} else if (amount < 0 || amount != amount) { cout << "negative moreblue amount (nan?): " << amount << endl;  amount = 0; }
	screen.screen[x][y].b[screenidx] += amount;
	if (screen.screen[x][y].b[screenidx] > 1.0f) screen.screen[x][y].b[screenidx] = 1.0f;
}

void Circuit8::lessBlue(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessblue amount (nan?) : " << amount << endl; amount = .01f; } else if (amount < 0 || amount != amount) { cout << "negative lessblue amount (nan?): " << amount << endl; amount = 0; }
	screen.screen[x][y].b[screenidx] -= amount;
	if (screen.screen[x][y].b[screenidx] < 0) screen.screen[x][y].b[screenidx] = 0;
}

void Circuit8::showScreenshot () {
	int content[18447]; // check if the pnm file uses only 8-bit channels
			    // and is half this size, somewhere
	string filename;
	filename = scrndir + "scrn.pnm";
	cout << "opens "<< filename << endl;

	int ctr = 0;

	for (ctr = 0;ctr<(64*48*3*2)+15;ctr++) {  // pnm header is 15 bytes for 64 x 48 x 65535
		content[ctr] = 0;
	}

	fileH.openbin( filename, content, (unsigned int) 18447 );

	cout << "opened" << endl;
	
	int x = 0;
	int y = 0;
	int adj = 0;
	for (ctr = 15;ctr<(64*48*3*2)+15;ctr+=6) {  // pnm header is 15 bytes for 64 x 48 x 65535
	  if (x+framecoloffset > 63) {
	  	adj = 1;
	  } else {
	  	adj = 0;
	  }
	  screenidx += adj;

	  screen.screen[(x+framecoloffset)%64][y].r[screenidx] /= 10;
//	  screen.screen[(x+framecoloffset)%64][y].r[screenidx] = 0;
	  
//	  cout << ( (((unsigned int) (unsigned char) content[ctr+0])+0)*256) + (((unsigned int) (unsigned char) content[ctr+1])+0) << " sdfsdf s" << endl;
//	  cout <<                            (float) ((float) ( (((unsigned int) (unsigned char) content[ctr+0])+0)*256) + (((unsigned int) (unsigned char) content[ctr+1])+0)) / 65535.0f << " sdfsdfsdfsdf " << endl;
//	  moreRed((x+framecoloffset)%64, y,  (float) ((float) ( (((unsigned int) (unsigned char) content[ctr+0])+0)*256) + (((unsigned int) (unsigned char) content[ctr+1])+0)) / 65535.0f);
	  moreRed((x+framecoloffset)%64, y,  (float) ((float) ( (((unsigned int) (unsigned char) content[ctr+0])+0)*256) + (((unsigned int) (unsigned char) content[ctr+1])+0)) / 65535.0f);

	  screen.screen[(x+framecoloffset)%64][y].g[screenidx] /= 10;
//	  moreGreen((x+framecoloffset)%64, y,(float) ((float) ( (((unsigned int) (unsigned char) content[ctr+2])+0)*256) + (((unsigned int) (unsigned char) content[ctr+3])+0)) / 65535.0f);
	  moreGreen((x+framecoloffset)%64, y,(float) ((float) ( (((unsigned int) (unsigned char) content[ctr+2])+0)*256) + (((unsigned int) (unsigned char) content[ctr+3])+0)) / 65535.0f);

	  screen.screen[(x+framecoloffset)%64][y].b[screenidx] /= 10;
//	  moreBlue((x+framecoloffset)%64, y, (float) ((float) ( (((unsigned int) (unsigned char) content[ctr+4])+0)*256) + (((unsigned int) (unsigned char) content[ctr+5])+0)) / 65535.0f);
	  moreBlue((x+framecoloffset)%64, y, (float) ((float) ( (((unsigned int) (unsigned char) content[ctr+4])+0)*256) + (((unsigned int) (unsigned char) content[ctr+5])+0)) / 65535.0f);

	  screenidx -= adj;

	  x += 1;
	  if (x == 64) {
	    x = 0;
	    y += 1;
	  }
	  if (y == 48) { // shouldnt happen ... well ... does
	    // cerr << "circuit8 oops... row count wrapped back to top, pnm supplied overlarge?" << endl;
	    y = 0;
          }
	}                                       	
}

void Circuit8::save()
{

	for ( unsigned int i = 0; i < 1026; i++ )
	{
		// determine filename
		stringstream fn;
		fn << savedir << "/" << "p-screen." << i;
		
		string filename = fn.str();

	        fstream file_op(filename.c_str(),ios::out);
	
		// save frames
		for (int x = 0;x<65;x++) {
			for (int y = 0;y<49;y++) {
/*				file_op.put((char) (int) (screen.screen[x][y].r[i]*256.0f));
				file_op.put((char) (int) (screen.screen[x][y].g[i]*256.0f));
				file_op.put((char) (int) (screen.screen[x][y].b[i]*256.0f)); */
				file_op.put((unsigned char) (unsigned int) (screen.screen[x][y].r[i]*255.0f));
				file_op.put((unsigned char) (unsigned int) (screen.screen[x][y].g[i]*255.0f));
				file_op.put((unsigned char) (unsigned int) (screen.screen[x][y].b[i]*255.0f));
			}
		}
                file_op.close();
	}
		
 	cerr << endl << "Saved psychic movie to " << savedir << endl << endl;
//	stringstream buf2;
//	buf2 << "Saved p-screen to " << savedir;
//	Logbuffer::Instance()->add(buf2);
}

unsigned int Circuit8::load()
{
        bool found = false;
        bool unfound = false;

	for ( unsigned int i = 0; i < 1026; i++ )
	{
		// determine filename
		stringstream fn;
		fn << loaddir << "/" << "p-screen." << i;
		
		string filename = fn.str();

	        fstream file_op(filename.c_str(),ios::in);
	        
                if (file_op) {
                  found = true;
                  // load frames
                  for (int x = 0;x<65;x++) {
			  for (int y = 0;y<49;y++) {
			          if (file_op.eof()) { cerr << "partial frame! "<< filename << endl; break; }
				  screen.screen[x][y].r[i] = ((float) (unsigned int) (unsigned char) file_op.get()) / 255.0f;
			          if (file_op.eof()) { cerr << "partial frame! "<< filename << endl; break; }
				  screen.screen[x][y].g[i] = ((float) (unsigned int) (unsigned char) file_op.get()) / 255.0f;
			          if (file_op.eof()) { cerr << "partial frame! "<< filename << endl; break; }
				  screen.screen[x][y].b[i] = ((float) (unsigned int) (unsigned char) file_op.get()) / 255.0f;
				  if (screen.screen[x][y].r[i] > 1.0f) { screen.screen[x][y].r[i] = 1.0f; }
				  if (screen.screen[x][y].g[i] > 1.0f) { screen.screen[x][y].g[i] = 1.0f; }
				  if (screen.screen[x][y].b[i] > 1.0f) { screen.screen[x][y].b[i] = 1.0f; }
                          }
                          if (file_op.eof()) { break; }
                  }
                  file_op.close();
                  stringstream buf2;
                  buf2 << "Loaded " << filename;
                  Logbuffer::Instance()->add(buf2);
                } else {
                  stringstream buf2;
                  buf2 << "No such file " << filename;
                  Logbuffer::Instance()->add(buf2);
                  unfound = true;
                }
        }
		
 	cerr << endl << "Loaded psychic movie " << savedir << endl << endl;
//	stringstream buf2;
//	buf2 << "Saved p-screen to " << savedir;
//	Logbuffer::Instance()->add(buf2);

        if (!found && !unfound) { return 3; } // pathological
        if ( found &&  unfound) { return 2; }
        if (!found &&  unfound) { return 1; }
        if ( found && !unfound) { return 0; }
}


Circuit8::~Circuit8()
{
}

#endif
