#ifndef PILL_H
#define PILL_H

#include "btBulletDynamicsCommon.h"
#include "GL/gl.h"

#include "../../utils/settings.h"
#include "../../utils/displaylists.h"
#include "entity.h"
#include "body.h"

using namespace std;


class Pill : public Entity
{
	public:
		Pill();
		~Pill();

		Body			body;
		void			createBody(btDynamicsWorld* m_dynamicsWorld, const btVector3& startOffset);
		void			removeBody();

		void			draw();
		
		btScalar		position[16];

 		float			color[5];

		unsigned int		lifetime;
		float			energyLevel;
		unsigned int		totalFrames;
		unsigned int		molecule; // 0 to 4 [0 inhibitory antagonist, 1 inhibitory agonist, 2 excitatory antagonist, 3 excitatory agonist, 4 potentiator]
//		bool			alive;
//		Pill*			real_pill;
//		Pill*			dummy_pill;

		btDefaultMotionState* myMotionState;
	private:
		Settings		*settings;

		btBoxShape* boxShape;
		btVector3 halfExtent;
};


#endif
